//=============================================================================
//
//  CLASS DirectionalLight - IMPLEMENTATION
//
//=============================================================================
#define RAYTRACER_POINTLIGHT_CPP

//== INCLUDES =================================================================
#include <cfloat>
#include "DirectionalLight.h"

//== IMPLEMENTATION ==========================================================

/*!

*/
void DirectionalLight::shadowFeeler( 
    Ray             &clRay,         
    double        &rRayDomain,    
    ColorType       &colIntensity )  const
{
    clRay.setDir( m_v3Direction );
    rRayDomain = FLT_MAX;
    colIntensity = m_colIntensity;
};


void DirectionalLight::renderGL(
    GLint   number )  const
{
    /*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
    VectorType3 direction = getDirection();
    GLfloat     light_position[] = { direction[0], direction[1], direction[2] };
    ColorType   color = getIntensity();
    GLfloat     light_ambient[] = { color.red(), color.green(), color.blue(), 1.0 };
    GLfloat     light_diffuse[] = { color.red(), color.green(), color.blue(), 1.0 };
    /*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

    glLightfv( number, GL_AMBIENT, light_ambient );
    glLightfv( number, GL_DIFFUSE, light_diffuse );
    glLightfv( number, GL_POSITION, light_position );
}
